#include <iostream> 
using namespace std;

struct Pema
{
	int e_dhena;       t dhnat e nyjes
	Pema* majtas;      nn pema e majt
	Pema* djathtas;    nn pema e djatht
};

Pema *NyjeRe(int vlera)
{
	Pema *nyje = new Pema;
	nyje->e_dhena = vlera;
	nyje->majtas = NULL;
	nyje->djathtas = NULL;

	return nyje;
}

Pema* insertoNyje(Pema *nyja, int vlera)
{
	static Pema *p;
	Pema *retNyje;

	if (nyja == NULL)
	{
		retNyje = NyjeRe(vlera);
		return retNyje;
	}
	if (vlera <= nyja->e_dhena)
	{
		p = nyja;
		nyja->majtas = insertoNyje(nyja->majtas, vlera);
	}
	else
	{
		p = nyja;
		nyja->djathtas = insertoNyje(nyja->djathtas, vlera);
	}
	return nyja;
}

void inOrder(Pema *n)Prshko nnpemn e majt, rrnjen, nnpemn e djatht
{
	if (n)
	{
		inOrder(n->majtas);
		cout << n->e_dhena << " ";
		inOrder(n->djathtas);
	}
}

void preOrder(Pema *n) Prshko rrnjen, nnpemn e majt, nnpemn e djatht
{
	if (n)
	{
		cout << n->e_dhena << " ";
		preOrder(n->majtas);
		preOrder(n->djathtas);
	}
}

void postOrder(Pema *n)Prshko nnpemn e majt, nnpemn e djatht, rrnjen
{
	if (n)
	{
		postOrder(n->majtas);
		postOrder(n->djathtas);
		cout << n->e_dhena << " ";
	}
}

int madhPemes(Pema *nyja)
{
	if (nyja == NULL) return 0;
	else
		return madhPemes(nyja->majtas) + 1 + madhPemes(nyja->djathtas);
}

int nrGjetheve(Pema* nyje)
{
	if (nyje == NULL)
		return 0;
	if (nyje->majtas == NULL && nyje->djathtas == NULL)
		return 1;
	else
		return nrGjetheve(nyje->majtas) + nrGjetheve(nyje->djathtas);
}

int MinMaxThellesi(Pema *nyja, bool min_max)
{
	if (nyja == NULL || (nyja->majtas == NULL && nyja->djathtas == NULL))
		return 0;

	int majThellesi = MinMaxThellesi(nyja->majtas, min_max);
	int djaThellesi = MinMaxThellesi(nyja->djathtas, min_max);

	if (min_max)
		return majThellesi > djaThellesi ? majThellesi + 1 : djaThellesi + 1;
	else
		return majThellesi < djaThellesi ? majThellesi + 1 : djaThellesi + 1;

}

bool eBalancuar(Pema *nyja)
{
	if (MinMaxThellesi(nyja, 1) - MinMaxThellesi(nyja, 0) <= 1)
		return true;
	else
		return false;
}

void gjejRrugen(Pema* nyja, int rruga[], int level)
{
	if (nyja == NULL) return;
	 leaf nyja save
	if (nyja->majtas == NULL && nyja->djathtas == NULL)
	{
		rruga[level] = nyja->e_dhena;
		int sum = 0;
		for (int i = 0; i <= level; i++)
		{
			cout << rruga[i] << " ";
			sum += rruga[i];
		}
		cout << "  distanca = " << sum << endl;
		return;
	}
	 parent nyja save
	rruga[level] = nyja->e_dhena;
	gjejRrugen(nyja->majtas, rruga, level + 1);
	gjejRrugen(nyja->djathtas, rruga, level + 1);
}

//Funksioni rekurziv per shtypje te nyjeve ne distancen k
void distancaK(Pema *rrenja, int k)
{
	if (rrenja == NULL)
		return;
	if (k == 0)
	{
		cout << rrenja->e_dhena << " ";
		return;
	}
	else
	{
		distancaK(rrenja->majtas, k - 1);
		distancaK(rrenja->djathtas, k - 1);
	}
}

int main()
{
	Pema *rrenja = NyjeRe(4);
	insertoNyje(rrenja, 2);
	insertoNyje(rrenja, 1);
	insertoNyje(rrenja, 3);
	insertoNyje(rrenja, 6);
	insertoNyje(rrenja, 5);
	insertoNyje(rrenja, 7);

	cout << "Rrugetimi in-order " << endl;
	inOrder(rrenja);
	cout << endl;

	cout << "Rrugetimi pre-order" << endl;
	preOrder(rrenja);
	cout << endl;

	cout << "Rrugetimi post-order" << endl;
	postOrder(rrenja);
	cout << endl;

	cout << "\nNumri i nyjave\n";
	cout << madhPemes(rrenja);

	cout << "\nNumri i gjetheve\n";
	cout << nrGjetheve(rrenja);

	cout << "\nThellsia maksimale pems\n";
	cout << MinMaxThellesi(rrenja, 1); 1 per max

	cout << "\nThellsia minimale pems\n";
	cout << MinMaxThellesi(rrenja, 0); 0 per min

	if (eBalancuar(rrenja))
		cout << "\nPema eshte e balancuar";
	else
		cout << "Pema nuk eshte e balancuar";

	cout << "\nLLogaritja e rrugetimeve\n";
	int rruga[10];
	gjejRrugen(rrenja, rruga, 0);

	distancaK(rrenja, 1);

	system("pause");
	return 0;
}
/*
 Pema e ndrtuar
		     4
         /   \
        2     6
       / \   / \
      1   3 5   7 
*/
