#include<iostream>
using namespace std;

struct Nyja
{
	char e_dhena;
	Nyja *majtas;
	Nyja *djathtas;
};

class BST
{
	Nyja *rrenja;
public:
	BST()
	{
		rrenja = NULL;
	}
	int eZbrazet()
	{
		return(rrenja == NULL);
	}
	void inserto(char elementi);
	void rrugetoInOrder();
	void InOrder(Nyja *n);
	void rrugetoPostOrder();
	void PostOrder(Nyja *n);
	void rrugetoPreOrder();
	void PreOrder(Nyja *);
	void largoNyjen(int val);
	Nyja* gjejNyjeSipasVleres(char vlera);
	Nyja* gjejPrindinPerNyjen(char vlera);
	Nyja* gjejNyjenDjathte(Nyja* p);

};

void BST::inserto(char vlera)
{
	Nyja *p = new Nyja;
	Nyja *prindi;
	p->e_dhena = vlera;
	p->majtas = NULL;
	p->djathtas = NULL;
	prindi = NULL;

	if (eZbrazet())
		rrenja = p;
	else
	{
		Nyja *ptr;
		ptr = rrenja;
		while (ptr != NULL)
		{
			prindi = ptr;
			if (vlera>ptr->e_dhena)
				ptr = ptr->djathtas;
			else
				ptr = ptr->majtas;
		}
		if (vlera<prindi->e_dhena)
			prindi->majtas = p;
		else
			prindi->djathtas = p;
	}
}

void BST::rrugetoInOrder()
{
	InOrder(rrenja);
}

void BST::InOrder(Nyja *ptr)
{
	if (ptr != NULL)
	{
		InOrder(ptr->majtas);
		cout << "  " << ptr->e_dhena << "     ";
		InOrder(ptr->djathtas);
	}
}

void BST::rrugetoPostOrder()
{
	PostOrder(rrenja);
}

void BST::PostOrder(Nyja *ptr)
{
	if (ptr != NULL)
	{
		PostOrder(ptr->majtas);
		PostOrder(ptr->djathtas);
		cout << "  " << ptr->e_dhena << "     ";
	}
}

void BST::rrugetoPreOrder()
{
	PreOrder(rrenja);
}

void BST::PreOrder(Nyja *ptr)
{
	if (ptr != NULL)
	{
		cout << "  " << ptr->e_dhena << "     ";
		PreOrder(ptr->majtas);
		PreOrder(ptr->djathtas);
	}
}

//gjen prindin e nyjs me vlern 'vlera'
Nyja* BST::gjejPrindinPerNyjen(char vlera)
{
	Nyja* p = rrenja;
	Nyja* q = 0;
	while ((p != NULL) && (p->e_dhena != vlera))
	{
		q = p;
		if (p->e_dhena>vlera)
			p = p->majtas;
		else
			p = p->djathtas;
	}
	return q;
}

//gjen nyjn me vlern 'vlera'
Nyja* BST::gjejNyjeSipasVleres(char vlera)
{
	Nyja* p = rrenja;
	while ((p != NULL) && (p->e_dhena != vlera))
	{
		if (p->e_dhena>vlera)
			p = p->majtas;
		else
			p = p->djathtas;
	}
	return p;
}

int main()
{
	BST b;
	b.inserto('D');
	b.inserto('B');
	b.inserto('A');
	b.inserto('C');
	b.inserto('F');
	b.inserto('G');

	cout << "InOrder\n";
	b.rrugetoInOrder();
	cout << endl << "PostOrder\n";
	b.rrugetoPostOrder();
	cout << endl << "PreOrder\n";
	b.rrugetoPreOrder();

	cout << "\nNyja me vleren C: ";
	cout<< b.gjejNyjeSipasVleres('C')<<endl;

	cout << "\nPrindi per nyjen C : ";
	cout << b.gjejPrindinPerNyjen('C') << endl;
	
	system("pause");
	return 0;
}